Index: tea4cups/trunk/COPYING
===================================================================
--- tea4cups/trunk/COPYING (revision 595)
+++ tea4cups/trunk/COPYING (revision 644)
@@ -3,6 +3,6 @@
 
  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
-                          59 Temple Place, Suite 330
-                          Boston, MA 02111-1307, USA.
+                          51 Franklin Street, Fifth Floor
+                          Boston, MA 02110-1301, USA.
  Everyone is permitted to copy and distribute verbatim copies
  of this license document, but changing it is not allowed.
@@ -307,5 +307,5 @@
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 Also add information on how to contact you by electronic and paper mail.
Index: tea4cups/trunk/tea4cups
===================================================================
--- tea4cups/trunk/tea4cups (revision 643)
+++ tea4cups/trunk/tea4cups (revision 644)
@@ -18,5 +18,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 # $Id$
Index: tea4cups/trunk/NEWS
===================================================================
--- tea4cups/trunk/NEWS (revision 631)
+++ tea4cups/trunk/NEWS (revision 644)
@@ -16,5 +16,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 =============================================================================
Index: tea4cups/trunk/tea4cups.conf
===================================================================
--- tea4cups/trunk/tea4cups.conf (revision 620)
+++ tea4cups/trunk/tea4cups.conf (revision 644)
@@ -4,4 +4,5 @@
 #
 # (c) 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2005 Peter Stuge <stuge-tea4cups@cdy.org>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,5 +17,5 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 # 
 #
@@ -35,7 +36,7 @@
 directory : /var/spool/cups/
 
-# Should Tea4CUPS keep the files it creates once all tees have ended ?
+# Should Tea4CUPS keep the files it creates once all hooks have ended ?
 # Defaults to No if unset, meaning that files are automatically deleted
-# once all tees have ended.
+# once all hooks have ended.
 # Can be set either in the [global] section or any print queue section.
 # The value defined in a print queue section takes precedence over the
@@ -44,10 +45,10 @@
 # keepfiles : yes
 
-# Should we serialize the launch of all tees : launch one tee after
+# Should we serialize the launch of all hooks : launch one after
 # the other to save some system resources.
-# Defaults to No if unset, meaning that all tees (or hooks) are launched in
+# Defaults to No if unset, meaning that all hooks are launched in
 # parallel.
 #
-# NB : in any case, hooks or tees names are sorted alphabetically and 
+# NB : in any case, hooks' names are sorted alphabetically and 
 # are launched in this sort order (obviously when launched in parallel
 # this is unnoticeable).
@@ -56,8 +57,7 @@
 # The value defined in a print queue section takes precedence over the
 # value defined in the [global] section.
-# This value also applies to prehooks and posthooks (see below)
 # serialize : yes
 
-# When executing the contents of a tee, prehook or posthook directive, 
+# When executing the contents of a prehook or posthook directive, 
 # tea4cups makes the following environment variables available to your
 # own commands :
@@ -83,16 +83,7 @@
 # since the first one may be empty depending on your printer driver.
         
-# Now defines some default tees which will always be launched
-# at the same time that the job's datas are being sent to the 
-# printer.
-# The tee names are completely free BUT THEY MUST BEGIN WITH 'tee_'
-#
-# These are just some stupid examples.
-#tee_0 : cat $TEADATAFILE >/tmp/$TEAJOBID.prn
-#tee_pdf : cat $TEADATAFILE | su -c "lp -dPDFGenerator" $TEAUSERNAME
-
 # Some hooks : prehooks and posthooks
 #
-# Contrary to tees, prehooks are guaranteed to be launched 
+# Prehooks are guaranteed to be launched 
 # BEFORE the job's datas are sent to the printer, and 
 # posthooks are guaranteed to be launched AFTER the job's
@@ -114,7 +105,9 @@
 # NB : as a special feature, any prehook which exits with a -1 status (255) 
 # causes the job to NOT be sent to the real backend, effectively cancelling it.
-# None of the tees and posthooks gets executed in this case, but all 
+# None of the posthooks gets executed in this case, but all 
 # remaining prehooks are still executed.
 # 
+#prehook_pdf : cat $TEADATAFILE | su -c "lp -dPDFGenerator" $TEAUSERNAME
+#posthook_0 : cat $TEADATAFILE >/tmp/$TEAJOBID.prn
 
 
@@ -124,17 +117,17 @@
 #[HP2100]
 #
-# By using a same tee name as in the [global] section, the new
+# By using a same hook name as in the [global] section, the new
 # value takes precedence
-#tee_0 : cat $TEADATAFILE >~$TEAUSERNAME/savejobs/$TEAJOBID.prn
+#posthook_0 : cat $TEADATAFILE >~$TEAUSERNAME/savejobs/$TEAJOBID.prn
 
 # An empty value deletes a value defined in the [global] section
-# so this particular tee doesn't get executed.
-#tee_pdf : 
+# so this particular hook doesn't get executed on this printer.
+#prehook_pdf : 
 
 # A reflector which produces 4 copies each time :
-#tee_4copies : lp -dotherprinter -n4 $CUPSDATAFILE 
+#posthook_4copies : lp -dotherprinter -n4 $CUPSDATAFILE 
 
 # A simple accounting mechanism 
-#tee_accounting : echo $TEAPRINTERNAME $TEAJOBID $TEAUSERNAME $TEABILLING `pkpgcounter $TEADATAFILE` >/var/log/printaccounting.log
+#prehook_accounting : echo $TEAPRINTERNAME $TEAJOBID $TEAUSERNAME $TEABILLING `pkpgcounter $TEADATAFILE` >/var/log/printaccounting.log
 
 # Some additionnal hooks to forbid duplicate jobs :
Index: tea4cups/trunk/CREDITS
===================================================================
--- tea4cups/trunk/CREDITS (revision 637)
+++ tea4cups/trunk/CREDITS (revision 644)
@@ -4,4 +4,5 @@
 
 (c) 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2005 Peter Stuge <stuge-tea4cups@cdy.org>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -16,5 +17,5 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 ============================================================
@@ -33,6 +34,5 @@
   The following people contributed to the Tea4CUPS project :
   
-  - Peter Stuge : allowed pre and post hooks to communicate through
-                  a pipe.
+  - Peter Stuge : rewrote most of the subprocess management stuff.
 
 ==============================================================
Index: tea4cups/trunk/README
===================================================================
--- tea4cups/trunk/README (revision 642)
+++ tea4cups/trunk/README (revision 644)
@@ -17,10 +17,9 @@
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
-Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 =============================================================================
 
-Tea4CUPS is the equivalent of the *nix command 'tee', but as a CUPS
-backend.
+Tea4CUPS resembles the *nix command 'tee', but is a CUPS backend.
 
 Tea4CUPS behaves just like any other CUPS backend, but allows you to
@@ -35,5 +34,8 @@
 message, all of this by printing it a single time.
 
-Tea4CUPS provides three ways to launch commands :
+Tea4CUPS allows this by permitting you to easily plug your own 
+commands into the very last stage of CUPS' filtering chain. 
+
+Tea4CUPS provides two ways to launch commands :
 
         - prehooks : these are guaranteed to be launched before the 
@@ -42,8 +44,4 @@
                      print job.
                      
-        - tees : these are launched at the same time the job is being             
-                 sent to the real printer, unless the job was 
-                 previously cancelled by a prehook.
-                 
         - posthooks : these are guaranteed to be launched after the
                       print job has been sent to the real printer,
@@ -97,5 +95,8 @@
         $ cp tea4cups /usr/lib/cups/backend
         
-  2 - Restart CUPS in order for this new backend to be detected.        
+  2 - Restart CUPS in order for this new backend to be detected.
+      NB : For this to work you need CUPS 1.1.15 or higher.
+      You can use Tea4CUPS with older versions if you want, but
+      without autodetection.
   
   3 - Either from CUPS' web interface, add new printers with 
@@ -104,4 +105,6 @@
       Or by directly modifying CUPS' printers.conf file, prepend    
       each DeviceURI value with 'tea4cups://', and restart CUPS.
+      (Use this last method if autodetection doesn't work because
+      the version of CUPS you use is too old)
       
   4 - Copy tea4cups.conf into CUPS' configuration directory (where    