Index: tea4cups/trunk/NEWS
===================================================================
--- tea4cups/trunk/NEWS (revision 644)
+++ tea4cups/trunk/NEWS (revision 645)
@@ -21,30 +21,30 @@
 
 Tea4CUPS News :
-   
+
   * 2.12alpha :
-  
+
     - Greatly improved the IPP parser.
-    
+
     - When printing test pages from CUPS' web interface, the empty username
       is now overwritten with the username CUPS is running as.
-    
+
   * 2.11 :
-  
+
     - Now works with old releases of Python (>= 2.1)
-    
+
     - More powerful error handling at startup time.
-    
-    - Ignores errors in posthooks because the job was probably 
+
+    - Ignores errors in posthooks because the job was probably
       successfully printed so no need to stop the print queue.
       We log a warning instead in this case.
-      
-  * 2.10 : 
-  
+
+  * 2.10 :
+
     - Makes the IPP message filename and the Job's billing code available.
-    
+
   * 2.00 :
 
     - Introduces the notions of pre and post hooks.
-    
+
     - Prehooks can decide to entirely cancel the print job if needed.
 
Index: tea4cups/trunk/tea4cups.conf
===================================================================
--- tea4cups/trunk/tea4cups.conf (revision 644)
+++ tea4cups/trunk/tea4cups.conf (revision 645)
@@ -9,14 +9,14 @@
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-# 
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-# 
+#
 #
 
@@ -50,8 +50,8 @@
 # parallel.
 #
-# NB : in any case, hooks' names are sorted alphabetically and 
+# NB : in any case, hooks' names are sorted alphabetically and
 # are launched in this sort order (obviously when launched in parallel
 # this is unnoticeable).
-# 
+#
 # Can be set either in the [global] section or any print queue section.
 # The value defined in a print queue section takes precedence over the
@@ -59,5 +59,5 @@
 # serialize : yes
 
-# When executing the contents of a prehook or posthook directive, 
+# When executing the contents of a prehook or posthook directive,
 # tea4cups makes the following environment variables available to your
 # own commands :
@@ -82,9 +82,9 @@
 # job's datas. Don't rely on TEAINPUTFILE, use TEADATAFILE instead
 # since the first one may be empty depending on your printer driver.
-        
+
 # Some hooks : prehooks and posthooks
 #
-# Prehooks are guaranteed to be launched 
-# BEFORE the job's datas are sent to the printer, and 
+# Prehooks are guaranteed to be launched
+# BEFORE the job's datas are sent to the printer, and
 # posthooks are guaranteed to be launched AFTER the job's
 # datas have been sent to the printer.
@@ -99,13 +99,13 @@
 # in the CUPS backend which handles the transmission of the job
 # to the printer.
-# 
+#
 # prehook_0 : echo "Your print job has been accepted" | smbclient -M $TEAUSERNAME
 # posthook_0 : echo "Your print job has been printed with status $TEASTATUS" | smbclient -M $TEAUSERNAME
 #
-# NB : as a special feature, any prehook which exits with a -1 status (255) 
+# NB : as a special feature, any prehook which exits with a -1 status (255)
 # causes the job to NOT be sent to the real backend, effectively cancelling it.
-# None of the posthooks gets executed in this case, but all 
+# None of the posthooks gets executed in this case, but all
 # remaining prehooks are still executed.
-# 
+#
 #prehook_pdf : cat $TEADATAFILE | su -c "lp -dPDFGenerator" $TEAUSERNAME
 #posthook_0 : cat $TEADATAFILE >/tmp/$TEAJOBID.prn
@@ -123,15 +123,15 @@
 # An empty value deletes a value defined in the [global] section
 # so this particular hook doesn't get executed on this printer.
-#prehook_pdf : 
+#prehook_pdf :
 
 # A reflector which produces 4 copies each time :
-#posthook_4copies : lp -dotherprinter -n4 $CUPSDATAFILE 
+#posthook_4copies : lp -dotherprinter -n4 $CUPSDATAFILE
 
-# A simple accounting mechanism 
+# A simple accounting mechanism
 #prehook_accounting : echo $TEAPRINTERNAME $TEAJOBID $TEAUSERNAME $TEABILLING `pkpgcounter $TEADATAFILE` >/var/log/printaccounting.log
 
 # Some additionnal hooks to forbid duplicate jobs :
 # The prehook will use the history file to filter out duplicate jobs
-# checkdupes is an hypothetical command which exits -1 if the current print 
+# checkdupes is an hypothetical command which exits -1 if the current print
 # job is a duplicate (same MD5 sum already found in history)
 #prehook_to_filter_duplicates : /usr/local/bin/checkdupes $TEAMD5SUM /tmp/jobmd5sums
Index: tea4cups/trunk/CREDITS
===================================================================
--- tea4cups/trunk/CREDITS (revision 644)
+++ tea4cups/trunk/CREDITS (revision 645)
@@ -26,12 +26,12 @@
   The following people supports the Tea4CUPS project enhancement
   by funding it :
-  
+
   - Anwar Bashir - University of Teesside
-  
+
 Contributors :
 --------------
 
   The following people contributed to the Tea4CUPS project :
-  
+
   - Peter Stuge : rewrote most of the subprocess management stuff.
 
@@ -41,9 +41,9 @@
   THINK YOU DESERVE TO BE LISTED, JUST SEND ME AN EMAIL
   ASKING FOR BEING INCLUDED.
-  
+
   I APOLOGIZE IN ADVANCE IF I'VE FORGOTTEN TO ADD YOUR NAME.
-  
-  ALSO, SOME PEOPLE MAY HAVE REFUSED TO BE LISTED HERE, THIS 
+
+  ALSO, SOME PEOPLE MAY HAVE REFUSED TO BE LISTED HERE, THIS
   IS YOUR RIGHT TO DO SO TOO, JUST TELL ME.
-  
+
 ==============================================================
Index: tea4cups/trunk/README
===================================================================
--- tea4cups/trunk/README (revision 644)
+++ tea4cups/trunk/README (revision 645)
@@ -30,23 +30,23 @@
 printers at the same time, which is not possible with CUPS.
 
-Another possibility would be for example to send the same document to 
+Another possibility would be for example to send the same document to
 a printer, a PDF generator, a Fax, and as an attachment to an email
 message, all of this by printing it a single time.
 
-Tea4CUPS allows this by permitting you to easily plug your own 
-commands into the very last stage of CUPS' filtering chain. 
+Tea4CUPS allows this by permitting you to easily plug your own
+commands into the very last stage of CUPS' filtering chain.
 
 Tea4CUPS provides two ways to launch commands :
 
-        - prehooks : these are guaranteed to be launched before the 
+        - prehooks : these are guaranteed to be launched before the
                      print job is sent to the real printer.
-                     Any prehook which exits -1 can cancel the 
+                     Any prehook which exits -1 can cancel the
                      print job.
-                     
+
         - posthooks : these are guaranteed to be launched after the
                       print job has been sent to the real printer,
                       unless the job was previously cancelled by a
                       prehook.
-                 
+
 To help your own commands, Tea4CUPS makes available as part of the
 environment several variables which can be used from the
@@ -67,8 +67,8 @@
         TEABILLING : Job's billing code (lp -o job-billing=SomeCode file.ps)
         TEACONTROLFILE : Job's IPP message file (usually /var/spool/cups/c?????)
-        TEASTATUS : Original CUPS backend's exit code : ONLY AVAILABLE FROM 
+        TEASTATUS : Original CUPS backend's exit code : ONLY AVAILABLE FROM
                     posthooks, obviously.
-        
-In the case you want to use both Tea4CUPS and PyKota, you MUST install 
+
+In the case you want to use both Tea4CUPS and PyKota, you MUST install
 PyKota v1.22alpha2 or higher to avoid a race condition.
 
@@ -81,60 +81,60 @@
 
   0 - Download Tea4CUPS from :
-  
+
         http://www.librelogiciel.com/software/Tea4CUPS/action_Presentation
-        
-      and extract it :  
-      
+
+      and extract it :
+
         $ tar -zxf tea4cups-x.yy.tar.gz
-        
+
         where x.yy is Tea4CUPS' version number.
-        
-  1 - Copy the 'tea4cups' command into CUPS' backend directory, 
+
+  1 - Copy the 'tea4cups' command into CUPS' backend directory,
       for example :
-      
+
         $ cp tea4cups /usr/lib/cups/backend
-        
+
   2 - Restart CUPS in order for this new backend to be detected.
       NB : For this to work you need CUPS 1.1.15 or higher.
       You can use Tea4CUPS with older versions if you want, but
       without autodetection.
-  
-  3 - Either from CUPS' web interface, add new printers with 
+
+  3 - Either from CUPS' web interface, add new printers with
       'Tea4CUPS managed' in front of the device's name.
-          
-      Or by directly modifying CUPS' printers.conf file, prepend    
+
+      Or by directly modifying CUPS' printers.conf file, prepend
       each DeviceURI value with 'tea4cups://', and restart CUPS.
       (Use this last method if autodetection doesn't work because
       the version of CUPS you use is too old)
-      
-  4 - Copy tea4cups.conf into CUPS' configuration directory (where    
+
+  4 - Copy tea4cups.conf into CUPS' configuration directory (where
       cupsd.conf resides) :
-      
+
         $ cp tea4cups.conf /etc/cups/
-        
-  5 - Modify tea4cups.conf to suit your needs. Several examples      
+
+  5 - Modify tea4cups.conf to suit your needs. Several examples
       are included.
-      
-  6 - There's no 6 !    
-  
+
+  6 - There's no 6 !
+
 =============================================================================
 
-Troubleshooting : 
+Troubleshooting :
 -----------------
 
   1 - Set "LogLevel debug2" in CUPS' cupsd.conf
-  
+
   2 - Restart CUPS.
-  
+
   3 - Set "debug: yes" in the [global] section of tea4cups.conf
-  
+
   4 - Print something on a print queue managed
       by Tea4CUPS.
-      
+
   5 - Look at CUPS' error_log file for diagnostic and error messages.
-  
+
 =============================================================================
 
-CUPS (Common UNIX(r) Printing System) is trademark property of Easy Software 
+CUPS (Common UNIX(r) Printing System) is trademark property of Easy Software
 Products.
 
@@ -144,4 +144,4 @@
 
 =============================================================================
-    
+
 Please e-mail bugs to : alet@librelogiciel.com (Jerome Alet)