Index: /pykota/trunk/conf/pykota.conf.sample
===================================================================
--- /pykota/trunk/conf/pykota.conf.sample (revision 695)
+++ /pykota/trunk/conf/pykota.conf.sample (revision 707)
@@ -31,5 +31,5 @@
 
 # Where to log ?
-# supported values : stderr, syslog
+# supported values : stderr, system (system means syslog, but don't use 'syslog' here)
 logger: stderr
 
Index: /pykota/trunk/pykota/loggers/system.py
===================================================================
--- /pykota/trunk/pykota/loggers/system.py (revision 707)
+++ /pykota/trunk/pykota/loggers/system.py (revision 707)
@@ -0,0 +1,43 @@
+# PyKota
+#
+# PyKota : Print Quotas for CUPS
+#
+# (c) 2003 Jerome Alet <alet@librelogiciel.com>
+# You're welcome to redistribute this software under the
+# terms of the GNU General Public Licence version 2.0
+# or, at your option, any higher version.
+#
+# You can read the complete GNU GPL in the file COPYING
+# which should come along with this software, or visit
+# the Free Software Foundation's WEB site http://www.fsf.org
+#
+# $Id$
+#
+# $Log$
+# Revision 1.1  2003/02/05 23:09:20  jalet
+# Name conflict
+#
+#
+#
+
+import sys
+import syslog
+
+class Logger :
+    """A logger class which logs to syslog."""
+    def __init__(self) :
+        """Opens the logging subsystem."""
+        syslog.openlog("PyKota", 0, syslog.LOG_LPR)
+        
+    def __del__(self) :    
+        """Ensures the logging subsystem is closed."""
+        syslog.closelog()
+        
+    def log_message(self, message, level) :
+        """Sends the message to syslog."""
+        try :
+            priority = getattr(syslog, "LOG_%s" % level.upper())
+        except AttributeError :    
+            # Bad priority name, we log this as a DEBUG message
+            priority = syslog.LOG_DEBUG
+        syslog.syslog(priority, message)
Index: /kota/trunk/pykota/loggers/syslog.py
===================================================================
--- /pykota/trunk/pykota/loggers/syslog.py (revision 695)
+++  (revision )
@@ -1,43 +1,0 @@
-# PyKota
-#
-# PyKota : Print Quotas for CUPS
-#
-# (c) 2003 Jerome Alet <alet@librelogiciel.com>
-# You're welcome to redistribute this software under the
-# terms of the GNU General Public Licence version 2.0
-# or, at your option, any higher version.
-#
-# You can read the complete GNU GPL in the file COPYING
-# which should come along with this software, or visit
-# the Free Software Foundation's WEB site http://www.fsf.org
-#
-# $Id$
-#
-# $Log$
-# Revision 1.1  2003/02/05 21:28:17  jalet
-# Initial import into CVS
-#
-#
-#
-
-import sys
-import syslog
-
-class Logger :
-    """A logger class which logs to syslog."""
-    def __init__(self) :
-        """Opens the logging subsystem."""
-        syslog.openlog("PyKota", 0, syslog.LOG_LPR)
-        
-    def __del__(self) :    
-        """Ensures the logging subsystem is closed."""
-        syslog.closelog()
-        
-    def log_message(self, message, level) :
-        """Sends the message to syslog."""
-        try :
-            priority = getattr(syslog, "LOG_%s" % level.upper())
-        except AttributeError :    
-            # Bad priority name, we log this as a DEBUG message
-            priority = syslog.LOG_DEBUG
-        syslog.syslog(priority, message)
Index: /pykota/trunk/pykota/config.py
===================================================================
--- /pykota/trunk/pykota/config.py (revision 695)
+++ /pykota/trunk/pykota/config.py (revision 707)
@@ -15,4 +15,7 @@
 #
 # $Log$
+# Revision 1.2  2003/02/05 23:09:20  jalet
+# Name conflict
+#
 # Revision 1.1  2003/02/05 21:28:17  jalet
 # Initial import into CVS
@@ -57,5 +60,5 @@
                 
         # more precise checks        
-        validloggers = [ "stderr", "syslog" ] 
+        validloggers = [ "stderr", "system" ] 
         if self.config.get("global", "logger").lower() not in validloggers :             
             raise PyKotaConfigError, "Option logger only supports values in %s" % str(validloggers)